﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Sample145862;
using MVCSampleBrowser.Models;
using Sample145862.Models;
using Sample142103;
using Syncfusion.JavaScript;
using System.Collections;
using Syncfusion.Linq;

namespace Sample145862.Controllers
{
    public class GridController : Controller
    {
        NorthwindDataContext db = new NorthwindDataContext();
      
        // GET: /Grid/
        public ActionResult GridFeatures()
        {
            return View();
        }
        public ActionResult Data(DataManager dm)
        {
            IEnumerable Data = OrderRepository.GetAllRecords();
            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                Data = operation.PerformSorting(Data, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                Data = operation.PerformWhereFilter(Data, dm.Where, dm.Where[0].Operator);
            }
            int count = Data.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                Data = operation.PerformSkip(Data, dm.Skip);
            }
            if (dm.Take != 0)
            {
                Data = operation.PerformTake(Data, dm.Take);
            }
            return Json(new { result = Data, count = count }, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        //Insert action
        public ActionResult Insert(EditableOrder value, string parentRowData)
        {
            OrderRepository.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        //Delete Action
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            return Json(key, JsonRequestBehavior.AllowGet);
        }
    }
}
